/**
 * @file IxOsslSymbols.c (Now map to OSAL symbols)
 *
 * @author Intel Corporation
 * @date 04-Oct-2002
 *
 * @brief This file declares exported symbols for linux kernel module builds.
 *
 * 
 * @par
 * IXP400 SW Release version 2.1
 * 
 * -- Copyright Notice --
 * 
 * @par
 * Copyright (c) 2001-2005, Intel Corporation.
 * All rights reserved.
 * 
 * @par
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Intel Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * 
 * @par
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * 
 * @par
 * -- End of Copyright Notice --
 */

#ifdef __linux

#include <linux/module.h>
#include <ix_ossl.h>

EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslThreadCreate);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslThreadKill);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslThreadSetPriority);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslTickGet);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslThreadDelay);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslSemaphoreWait);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslSemaphorePost);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardSemaphoreDestroy);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslMutexInit);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslMutexLock);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslMutexUnlock);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslMutexDestroy);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslSleepTick);
EXPORT_SYMBOL (ixOsalOsIxp400BackwardOsslTimeGet);



#endif /* __linux */
